% Here for matlab, we always save data array in the dimension consequence
% of (z,y,x,t).

function dataout=idata(par)
% Same as idata, but the restart is took care of, No need to run 'cv.f'.
input_data

fid = fopen([data_dir,par,'.out']);

if (par(end-1:end)=='xy'|par(end-1:end)=='xz') % data generated by phixy or phixz
    head = textscan(fid,'%n', 5); 
    im = head{1}(1); jm = head{1}(2); tm = head{1}(3); nplot = head{1}(4); ddt = head{1}(5);
    arrayl = (im+1)*(jm+1);    
    t = 1;
    while 1
        timehead = textscan(fid,'%s %s %n',1);
        if isempty(timehead{1}) == 1, t-1, break, end
        tmm(t) = timehead{3}/100+1;
        ccc = textscan(fid,'%f',arrayl);
        if (t>1 && tmm(t) == tmm(t-1)), continue, end
        for j=1:jm+1
            for i=1:im+1
                dataout(j,i,t)=ccc{1}(i+(im+1)*(j-1)); % Always write j first for (j, i, t)!
            end
        end
        t=t+1;
    end
elseif (par(end)=='r') % data generated by aphir
    head = textscan(fid,'%n', 4); 
    im = head{1}(1); tm = head{1}(2); nplot = head{1}(3); ddt = head{1}(4);
    arrayl = im+1;
    t = 1;
    while 1
        timehead = textscan(fid,'%s %s %n',1);
        if isempty(timehead{1}) == 1, t-1, break, end
        tmm(t) = timehead{3}/100+1;
        ccc = textscan(fid,'%f',arrayl);
        if (t>1 && tmm(t) == tmm(t-1)), continue, end
        for i=1:im+1
            dataout(i,t)=ccc{1}(i); 
        end
        t=t+1;
    end
elseif (par(end-1:end)=='3d') % 3D data
    head = textscan(fid,'%n', 4); 
    im = head{1}(1); jm = head{1}(2); km = head{1}(3); tm = head{1}(4); % need a tm here in the *3d.out file
    arrayl = (im+1)*(jm+1)*(km+1);  
    for t=1:tm-1
        ccc = textscan(fid,'%f',arrayl);
        for k=1:km+1
            for j=1:jm+1
                for i=1:im+1
                    dataout(k,j,i,t)=ccc{1}(i+(im+1)*(j-1)+(im+1)*(jm+1)*(k-1));
                end
            end
        end
    end
end
    
fclose(fid);

return 