%clear all
input_data
fid = fopen([data_dir,'eqdat']);

C1=textscan(fid,'%f %f %f %f %f %f %f', 1);
r0a = C1{1}; lxa = C1{2}; beta=C1{3}; a=C1{4}; rmaj0=C1{5}; 
tir0 = C1{6}; xnir0 = C1{7};

C2=textscan(fid,'%n %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f',301);
i=C2{1}; t0i=C2{2}; t0e=C2{3}; capti=C2{4}; capte=C2{5}; xn0e=C2{6};
capne=C2{7}; er=C2{8}; gper=C2{9}; sf=C2{10}; 
elon=C2{11}; tria=C2{12}; rmaj=C2{13}; 
selon=C2{14}; stria=C2{15}; srmaj=C2{16};

C3=textscan(fid,'%f',301);
u1=C3{1};

C4=textscan(fid,'%f',301);
u2=C4{1};

fclose(fid);

ra=r0a-lxa/2:lxa/300:r0a+lxa/2; ra=ra';

subplot(2,3,1)
plot(ra,xn0e,'LineWidth',1.5)
xlim([ra(1), ra(300)])
title('xn0e')

subplot(2,3,4)
plot(ra,capne,'LineWidth',1.5)
%xlim([0.9, 1])
xlim([ra(1), ra(300)])
%line([0.989,0.989],[0,0.4],'LineStyle','--')
%line([0.939,0.939],[0,0.4],'LineStyle','--')
title('capne')

subplot(2,3,2)
plot(ra,t0i,'LineWidth',1.5)
%xlim([0.9, 1])
xlim([ra(1), ra(300)])
title('t0i')

subplot(2,3,5)
plot(ra,capti,'LineWidth',1.5)
%xlim([0.9, 1])
xlim([ra(1), ra(300)])
%line([0.989,0.989],[0,0.03],'LineStyle','--')
%line([0.939,0.939],[0,0.03],'LineStyle','--')
title('capti')

subplot(2,3,3)
plot(ra,t0e,'LineWidth',1.5)
%xlim([0.9, 1])
xlim([ra(1), ra(300)])
title('t0e')

subplot(2,3,6)
plot(ra,capte,'LineWidth',1.5)
%xlim([0.9, 1])
xlim([ra(1), ra(300)])
title('capte')
set(gcf,'PaperPositionMode','auto')
set(gcf,'Position',[700 250 550 700])

ln = 1/max(capne)
lti = 1/max(capti)
lte = 1/max(capte)

%  ln = 1/max(capne.*sqrt(tir0/2./t0i))
%  lti = 1/max(capti.*sqrt(tir0/2./t0i))
%  lte = 1/max(capte.*sqrt(tir0/2./t0i))

%return

figure(2)
subplot(2,1,1)
plot(ra,er,'b-',ra,gper,'r--','LineWidth',1.5)
legend('E_r','experimental \nabla P_i/n_i','FontSize',14)
%xlim([0.9, .998])
xlim([ra(1), ra(300)])
title('E_r','FontSize',14)
set(gca,'FontSize',14)
pbaspect([1.5 1 1])
set(gcf,'PaperPositionMode','auto')
subplot(2,1,2)
ranew=ra(1:end-1)+(ra(2)-ra(1))/2;
plot(ranew,diff(er)./diff(ra)/a,'b-',ranew,diff(gper)./diff(ra)/a,'r--')
legend('from E_r','from experimental \nabla P_i/n_i','FontSize',14)
xlim([ra(1), ra(300)])
title('\gamma_E=dE_r/dr','FontSize',14)
set(gca,'FontSize',14)
%set(gcf,'Position',[50 450 550 450])
pbaspect([1.5 1 1])
set(gcf,'Position',[50 250 550 700])
%return

figure(3)
dqdr=(sf(246)-sf(36))/(ra(246)-ra(36));
shat=ra./sf*dqdr;
plot(ra,sf,'-b')%,ra,shat,'--r','LineWidth',1.5)
xlim([ra(1), ra(300)])
%legend('q')
%title('Magnetic shear','FontSize',14)
title('q profile','FontSize',14)
xlabel('r/a','FontSize',14)
%legend('q','\hat{s}','FontSize',14)
set(gca,'FontSize',14)
pbaspect([1.5 1 1])
set(gcf,'PaperPositionMode','auto')

%return

raa=ra(2:end-1); lln=1./capne(2:end-1); llti=1./capti(2:end-1);
llte=1./capte(2:end-1);

figure(4)
plot(raa,lln./llti,'-r',raa,lln./llte,'--b')
xlim([ra(1), ra(end)])
xlabel('r/a','FontSize',14)
set(gca,'FontSize',14)
legend('\eta_i','\eta_e','FontSize',14)
pbaspect([1.5 1 1])
set(gcf,'PaperPositionMode','auto')


%return

figure(8)
%omega_*, assuming n=10
%k_theta=nq/r
nn=14
osn=nn*sf(2:end-1)./(raa*a).*t0i(2:end-1)/tir0./lln;
osti=nn*sf(2:end-1)./(raa*a).*t0i(2:end-1)/tir0./llti;
oste=nn*sf(2:end-1)./(raa*a).*t0i(2:end-1)/tir0./llte;
ospi = osn+osti;

betai=beta*xn0e(2:end-1).*t0i(2:end-1)/(xnir0*tir0)*2;
betae=beta*xn0e(2:end-1).*t0e(2:end-1)/(xnir0*tir0)*2;
vA=sqrt(t0i(2:end-1)/tir0./betai/2); %m_i=2
omA=vA./sf(2:end-1)/rmaj0;

plot(raa,betai,raa,betae)
legend('\beta_i','\beta_e')
xlim([raa(1),raa(end)])
xlabel('r/a')

% subplot(2,1,1)
% plot(raa,osn,'-k',raa,osti,'--r',raa,oste,'-.b')
% legend('\omega_{*}','\omega_{*T_i}','\omega_{*T_e}')
% pbaspect([1.5 1 1])
% xlim([ra(1), ra(end)])
% title(['n= ',num2str(nn)])
% 
% subplot(2,1,2)
% plot(raa,omA)
% title('\omega_A')
% pbaspect([1.5 1 1])
% xlim([ra(1), ra(end)])
% set(gcf,'Position',[50 250 550 700])

%return

figure(9)
omb=sqrt(t0e(2:end-1)/t0i(1)*1837)./sf(2:end-1)/rmaj0.*sqrt(raa*a/2/rmaj0);
plot(raa,omb)
xlabel('r')
xlim([ra(1), ra(end)])
title('Trapped electron bounce frequency')

%return

% Calculating alpha ...
bt=4*beta*xn0e.*t0i/(xn0e(1)*t0i(1));
olp=capne+(capti.*t0i+capte.*t0e)./(t0i+t0e);
alpha=sf.^2*rmaj0.*bt.*olp;

figure(5)
subplot(2,1,1)
plot(ra,alpha)
xlabel('r/a')
ylabel('\alpha')
xlim([0.9 0.998])
subplot(2,1,2)
plot(ra,bt)
xlabel('r/a')
ylabel('\beta')
xlim([0.9 0.998])
%return

figure(5)
subplot(3,1,1)
plot(ra,elon,'LineWidth',1.5)
xlim([ra(1), ra(end)])
title('elon','FontSize',14)
subplot(3,1,2)
plot(ra,tria,'LineWidth',1.5)
xlim([ra(1), ra(end)])
title('tria','FontSize',14)
subplot(3,1,3)
plot(ra,rmaj,'LineWidth',1.5)
xlim([ra(1), ra(end)])
title('rmaj','FontSize',14)
set(gcf,'PaperPositionMode','auto')

figure(6)
subplot(3,1,1)
plot(ra,selon,'LineWidth',1.5)
xlim([ra(1), ra(end)])
title('selon','FontSize',14)
subplot(3,1,2)
plot(ra,stria,'LineWidth',1.5)
xlim([ra(1), ra(end)])
title('stria','FontSize',14)
subplot(3,1,3)
plot(ra,srmaj,'LineWidth',1.5)
xlim([ra(1), ra(end)])
title('srmaj','FontSize',14)
set(gcf,'PaperPositionMode','auto')

'Miller parameters:'
a
R0=rmaj(150)
R_a=R0/a
shafranov_shift=srmaj(150)
q0=sf(150)
kappa=elon(150)
s_kappa=selon(150)
delta=tria(150)
s_delta=stria(150)
beta_e=betae(150)
T_i=t0i(150)
T_e=t0e(150)
Ti_Te=T_i/T_e
n_e=xn0e(150)
dTi_d_rho=capti(150)*a*T_i
dTe_d_rho=capte(150)*a*T_e
dn_d_rho=capne(150)*a*xn0e(150)

return
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(3)
plot(ra,capne,ra,capti,ra,capte)
legend('capne','capti','capte')
xlim([0.9, 1])

figure(4)
semilogy(ra,capti./capne)
xlim([0.9, 1])

return
plot(ra,capne)

return

toif=-37.2924+86.5651*ra-48.8967*ra.^2;
plot(ra,t0i,ra,toif)